#!/usr/bin/env python
# weili@jimmy.harvard.edu

import sys
from numarray import *

class Matrix(object):
    '''self.probes=[ (ChipID, pos, array1, array2,...), (ChipID, pos, array1, array2,...),...]'''
    def __init__(self, filename):
        self.filename = filename
        self.celnames =''
        self.num_exp = ''
        self.num_probe = ''
        self.chr = ''

        #file header
        self.filehandle = open(filename)
        for  x in  self.filehandle :
            if x[:4] == '#chr':
                self.chr = x[1:-1]
            if x[0] == '#' :
                continue
            if x.split()[0] == 'ChipID' :
                self.celnames = x.split()[2:]
                break
        self.num_exp =  len(self.celnames)

    def Read(self):
        '''get data '''
        self.probes = []
        print >> sys.stderr, "Reading matrix file ", self.filename
        for x in self.filehandle:
            x = x.split()
            if not x[0].isdigit():
                continue

        #real data begin
            x =  [float(i) for i in x  ]
            self.probes.append(  x )

            if x[1] % 100000 == 0:
                print >> sys.stderr, x[1]
        self.num_probe = len(self.probes)
        self.probes = array(self.probes)



        
