PYTHONHEAD=~/local/include/python2.4/
PYTHONLIB=~/local/lib/python2.4/config/
echo $PYTHONLIB


#install BPMAP
g++ -g  -Wno-deprecated -D_GCC -c BPMAPFileData.cpp FileIO.cpp CELFileData.cpp
swig -c++ -python BPMAP.i
g++ -g -Wno-deprecated -D_GCC -c BPMAP_wrap.cxx -I $PYTHONHEAD
g++ -shared BPMAPFileData.o  FileIO.o BPMAP_wrap.o -o _BPMAP.so -L  $PYTHONLIB -lpython2.4

#install CEL
swig -c++ -python CEL.i
g++ -g -Wno-deprecated -D_GCC -c CEL_wrap.cxx -I $PYTHONHEAD
g++ -shared CELFileData.o  FileIO.o CEL_wrap.o -o _CEL.so -L   $PYTHONLIB -lpython2.4

#install FileIO
cd FileIO
g++  -g  -Wno-deprecated -D_GCC  -c CELFileData.cpp    FileIO.cpp FileWriter.cpp AB_CELFile.cpp
swig -c++ -python AB_CELFile.i 
g++ -g -Wno-deprecated -D_GCC -c AB_CELFile_wrap.cxx  -I $PYTHONHEAD 
g++ -shared CELFileData.o FileIO.o FileWriter.o AB_CELFile.o AB_CELFile_wrap.o -o _libAffx_Bruce_CELFile.so -L $PYTHONLIB 
